=begin
#OpenAPI

#tinkoff.ru/invest OpenAPI.

The version of the OpenAPI document: 1.0.0
Contact: al.a.volkov@tinkoff.ru
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.0.1

=end

require 'cgi'

module TinkoffInvestClient
  class PortfolioApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Получение валютных активов клиента
    # @param [Hash] opts the optional parameters
    # @option opts [String] :broker_account_id Номер счета (по умолчанию - Тинькофф)
    # @return [PortfolioCurrenciesResponse]
    def portfolio_currencies_get(opts = {})
      data, _status_code, _headers = portfolio_currencies_get_with_http_info(opts)
      data
    end

    # Получение валютных активов клиента
    # @param [Hash] opts the optional parameters
    # @option opts [String] :broker_account_id Номер счета (по умолчанию - Тинькофф)
    # @return [Array<(PortfolioCurrenciesResponse, Integer, Hash)>] PortfolioCurrenciesResponse data, response status code and response headers
    def portfolio_currencies_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PortfolioApi.portfolio_currencies_get ...'
      end
      # resource path
      local_var_path = '/portfolio/currencies'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'brokerAccountId'] = opts[:'broker_account_id'] if !opts[:'broker_account_id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PortfolioCurrenciesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['sso_auth']

      new_options = opts.merge(
        :operation => :"PortfolioApi.portfolio_currencies_get",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PortfolioApi#portfolio_currencies_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Получение портфеля клиента
    # @param [Hash] opts the optional parameters
    # @option opts [String] :broker_account_id Номер счета (по умолчанию - Тинькофф)
    # @return [PortfolioResponse]
    def portfolio_get(opts = {})
      data, _status_code, _headers = portfolio_get_with_http_info(opts)
      data
    end

    # Получение портфеля клиента
    # @param [Hash] opts the optional parameters
    # @option opts [String] :broker_account_id Номер счета (по умолчанию - Тинькофф)
    # @return [Array<(PortfolioResponse, Integer, Hash)>] PortfolioResponse data, response status code and response headers
    def portfolio_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PortfolioApi.portfolio_get ...'
      end
      # resource path
      local_var_path = '/portfolio'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'brokerAccountId'] = opts[:'broker_account_id'] if !opts[:'broker_account_id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PortfolioResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['sso_auth']

      new_options = opts.merge(
        :operation => :"PortfolioApi.portfolio_get",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PortfolioApi#portfolio_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
